#include <stdio.h>
#include "app/Application.h"   // Be's BApplication class, necessary for any GUI stuff
#include "interface/Window.h"  // Be's BWindow class
#include "interface/View.h"    // Be's BView class
#include "interface/Button.h"  // Be's BButton class

const uint32 COMMAND_LAUNCH_NUKES = 'Lnch';

/* My custom BWindow subclass... */
class NukesWindow : public BWindow
{
public:
   NukesWindow();
   
   virtual void MessageReceived(BMessage * msg);
   virtual bool QuitRequested();
};

NukesWindow :: NukesWindow()
   : BWindow(BRect(50,50,250,150), "Button BWindow!", B_DOCUMENT_WINDOW, 0)
{
   // Fill this window with a nice light green background BView...
   BView * view = new BView(Bounds(), NULL, B_FOLLOW_ALL_SIDES, 0);
   view->SetViewColor(100,255,0);
   AddChild(view);

   // And put a nice BButton inside the view.
   BRect buttonRect = view->Bounds();
   buttonRect.InsetBy(20,30);  // we'll make the button a bit smaller than the view

   BButton * button = new BButton(buttonRect, NULL, "Launch nukes!", new BMessage(COMMAND_LAUNCH_NUKES), B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FULL_UPDATE_ON_RESIZE);
   button->SetTarget(this);  // so that when the button is pressed, its BMessage is sent to this window.
   view->AddChild(button);
}

// Called whenever our window gets a BMessage.  (e.g. from our button)
void NukesWindow :: MessageReceived(BMessage * msg)
{
   printf("NukesWindow got a message!  The message is:  "); 
   msg->PrintToStream();

   switch(msg->what)
   {
      case COMMAND_LAUNCH_NUKES: 
         printf("\n\nLAUNCH NUKES!!! LAUNCH NUKES!!! LAUNCH NUKES!!!\n\n\n");
      break;

      default:
         BWindow :: MessageReceived(msg);  // all other types go to the parent class's method.
      break;
   }
}

// Called when the user clicks on the window's close box
bool NukesWindow :: QuitRequested()
{
   be_app->PostMessage(B_QUIT_REQUESTED);  // tell the application to quit too
   return true;  // and indicate that it's okay for us to close
}

// Demonstrates a BWindow with a BView and a BButton.  Compile like this:
// gcc window.cpp -lbe
int main(int argc, char ** argv)
{
   BApplication app("application/x-vnd.Sugoi-sillybuttondemo");  // gotta have this!

   // Create the window...
   BWindow * window = new NukesWindow();
   window->Show();  // starts the window's thread and displays the window

   app.Run();  // Doesn't return until the application quits.  Note that for this
               // demo, it will block even after the window is closed.  You'll
               // probably need to control-C to quit!

   return 0;
}
