#include <stdio.h>
#include "kernel/OS.h"

const uint32 LOOP_LENGTH = 500000000;
static uint32 counter = 0;

long threadFunc(void *);
long threadFunc(void *)
{
   for (int i=0; i<LOOP_LENGTH; i++) counter = counter + 1;   // race happens here (even if we did counter++ instead!)
}

// This app will demonstrate a race condition between two threads.
// Both threads will increment the counter LOOP_LENGTH times.
// At the end of the program, you might expect the value of the
// counter to be LOOP_LENGTH*2, but it probably won't be, due to 
// the race condition!
int main(int argc, char ** argv)
{
   // Create the separate thread here...
   thread_id launchedThread = spawn_thread(threadFunc, "counter thread", B_NORMAL_PRIORITY, NULL); 
   if (launchedThread >= 0)
   {
      resume_thread(launchedThread);  // gotta do this to start it running

      // Do some counting in this thread too
      threadFunc(NULL);

      status_t threadResult;
      wait_for_thread(launchedThread, &threadResult);

      printf("At the end, counter's value is %lu (should be %lu)\n", counter, LOOP_LENGTH*2);
   }
   else printf("Error launching thread!??!?\n");

   return 0; 
}
