#include <stdio.h>
#include "kernel/OS.h"

long threadFunc(void * arg);
long threadFunc(void * arg)
{
   printf("Launched thread starting...\n");

   for (int i=0; i<25; i++)
   {
      printf("Launched thread counted %i\n", i+1);
      snooze(100000);
   }
   printf("Launched thread exiting.\n");
   return 77;  // any number you want could be returned, really
}

int main(int argc, char ** argv)
{
   printf("This app will demonstrate launching a separate thread.\n");
   printf("While the main thread counts to 25 in the foreground,\n");
   printf("The launched thread will count to 25 simultaneously.\n");
   printf("\n\n");

   // Create the separate thread here...
   thread_id launchedThread = spawn_thread(threadFunc, "counter thread", B_NORMAL_PRIORITY, NULL); 
   if (launchedThread >= 0)
   {
      resume_thread(launchedThread);  // gotta do this to start it running

      printf("Thread launched, now I'll do a little counting myself!\n");
      for (int i=0; i<25; i++)
      {
         printf("Main thread counted %i\n", i+1);
         snooze(70000);
      }

      printf("Main thread finished.  I'll now wait for the\n");
      printf("Launched thread to exit before continuing.\n");

      status_t threadResult;
      wait_for_thread(launchedThread, &threadResult);
      printf("Main thread:  okay, the launched thread finished, and returned code %li\n", threadResult);
   }
   else printf("Error launching thread!??!?\n");

   printf("Main thread exiting\n");

   return 0; 
}
